(function ($, Drupal) {
  Drupal.behaviors.simpleFavsBlockRender = {
    attach: function (context, settings) {
	    console.log('Simple favs block.');
      once('simple-favs-render', '[data-block-plugin-id="simple_favs_block"]', context).forEach(function (block) {
        const favs = Drupal.behaviors.simpleFavs.getFavs();
        const $block = $(block);

        if ($block.length) {
          $block.empty();
          const keys = Object.keys(favs);
          if (keys.length === 0) {
            $block.append('<p>' + Drupal.t('There currently are no selected favourites.') + '</p>');
          }
          else {
            $.getJSON('/simple-favs/titles', { ids: keys }, function (titleMap) {
              const list = $('<ul class="simple-favs-list"></ul>');
              keys.forEach(function (id) {
                const title = titleMap[id] || 'Content ID: ' + id;
                const item = $('<li></li>').text(title);
                list.append(item);
              });
              $block.append(list);
            });
          }
        }
      });
    }
  };
})(jQuery, Drupal);

