<?php

namespace Drupal\simple_favs\Plugin\Block;

use Drupal\Core\Block\BlockBase;
use Drupal\Core\StringTranslation\StringTranslationTrait;

/**
 * Provides a "My Favourites" block for Simple Favs.
 *
 * @Block(
 *   id = "simple_favs_block",
 *   admin_label = @Translation("My Favourites"),
 * )
 */
class SimpleFavsBlock extends BlockBase {
  use StringTranslationTrait;

  /**
   * {@inheritdoc}
   */
  public function build() {
    return [
      '#type' => 'container',
      '#attributes' => [
        'id' => 'simple-favs-block',
        'class' => ['simple-favs-wrapper'],
      ],
      'fallback' => [
        '#markup' => '<p>' . $this->t('There currently are no selected favourites.') . '</p>',
      ],
      '#attached' => [
        'library' => [
          'simple_favs/favs', // Our JS library.
        ],
      ],
    ];
  }

}

